package hatelace.memtypes;

import hatelace.Word;

public class LongWord extends Word {
    private Long value;

    public LongWord(Long value) {
        this.value = value;
    }

    @Override
    @SuppressWarnings("unchecked") // Not a good look
    public Long getValue() {
        return value;
    }

    public Word add(Word other) {
        return new LongWord(value + (Long) other.getValue());
    }

    public Word subtract(Word other) {
        return new LongWord(value - (Long) other.getValue());
    }

    public Word multiply(Word value) {
        return new LongWord(this.value * (Long) value.getValue());
    }

    public Word divide(Word other) {
        return new LongWord(value / (Long) other.getValue());
    }

    public String toString() {
        return value.toString();
    }

    public boolean equals(Object other) {
        return value.equals(((LongWord) other).getValue());
    }
}
